/**
 * funkcja sprawdzająca poprawność adresu email
 * 
 * @param {String} email
 */
function checkEmail(email) {
    var reg_test = /^[\w\.-]{2,}@[\w\.-]+\.[a-z]{2,5}$/i.test(email);
    if (!reg_test)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca poprawność godziny
 * 
 * @param {String} h
 */
function checkHour(h) {
    /* var reg_test = /^[0-9]{1,2}\:[0-9]{2}\:[0-9]{2}$/i.test(h); */
    var reg_test = /^[0-9]{1,2}\:[0-9]{2}$/i.test(h);
    if (!reg_test)
        return reg_test;
    var val = h.split(':');
    if (val[0] > 23 || val[0] < 0 || val[1] > 59 || val[1] < 0 || val[2] > 59
        || val[2] < 0)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca poprawność numeru telefonu
 * 
 * @param {string} pN
 */
function checkPhoneNumber(pN) {
    var reg_test = /^[0-9]{10}$/i.test(pN);
    if (!reg_test)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca poprawność adresu WWW
 * 
 * @param {String} www
 */
function checkWWW(www) {
    var reg_test = /^(http:\/\/|www\.).*/i.test(www);
    if (!reg_test)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca poprawność kodu pocztowego
 * 
 * @param {String} zC
 */
function checkZipCode(zC) {
    var reg_test = /^[0-9]{2}\-[0-9]{3}$/i.test(zC);
    if (!reg_test)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca, czy długość string-a zawiera się w przedziale
 * 
 * @param {string} str
 * @param {int} from
 * @param {int} to
 */
function checkLength(str, from, to) {
    if (str.length >= from && str.length <= to)
        return true;
    return false;
}

/**
 * funkcja sprawdzająca poprawność loginu uzytkownika
 * 
 * @param {string} login
 */
function checkLogin(login) {
    var reg_test = /^[\w\.-]{8,50}$/i.test(login);
    if (!reg_test)
        return false;
    return true;
}

/**
 * funkcja sprawdzająca zgodność z typem int
 * 
 * @param {Object} value
 */
function checkInt(value) {
    var reg_test = /^[\-]{0,1}[0-9]{1,8}$/i.test(value);
    if (!reg_test)
        return false;
    return true;
}

/**
 * Backtrace dla funkcji JavaScript
 * 
 * @param {Object} func
 */

function getStackTrace(func) {

    if (!func)
        return "not a function!";
    var trace = getFuncName(func);
    var args = "(";
    for ( var arg in func.arguments) {
        if (args && args.length && args.length > 1)
            args += ",";
        args += func.arguments.toString();
    }

    trace += args + ")\n";
    return trace + getStackTrace(func.caller);
}

/**
 * funkcja wychwytująca błędy
 */

function handleErrors(errStr, url, lineNum) {
    document.getElementById('JSError').innerHTML = getStackTrace();
}
// window.onerror=handleErrors;

/**
 * funkcja potwierdzająca wykonaną akcję
 * 
 */
function confirmSubmit(str) {
    var agree = confirm(str);

    if (agree) {
        return true;
    }
    return false;
}

/**
 * funkcja zwalnia aktywne zakladki, przyciski i aktywuje wybrana jako aktywna
 * (newsy na stronie glownej, box galerii strony glownej) ile - calkowita ilosc
 * zakladek cur - numer zakladki do aktywacji id - tekstowy przedrostek id
 * zakladek, przyciskow
 */
function activateGroup(ile, cur, id) {
    for ( var i = 0; i <= ile; i++) {
        if (document.getElementById(id + i)) {
            document.getElementById(id + i).className = '';
        }
    }
    document.getElementById(id + cur).className = 'sel';
}

// ==========================================
// Check All boxes
// ==========================================
function CheckAll(fmobj)
{
    for(var i=0; i<fmobj.elements.length; i++) {
        var e=fmobj.elements[i];
        if((e.type == 'checkbox') && (!e.disabled) && (e.id != 'search_select_all') && (e.id != 'search_aktualne') && (e.id != 'search_archiwalne')) {
            e.checked = document.getElementById('search_select_all').checked;
        }
    }
}

// ==========================================
// Check all or uncheck all?
// ==========================================
function CheckCheckAll(fmobj)
{
    var TotalBoxes = 0;
    var TotalOn = 0;
    for(var i=0; i<fmobj.elements.length; i++)
    {
        var e=fmobj.elements[i];
        if((e.type == 'checkbox') && (e.id != 'search_select_all') && (e.id != 'search_aktualne') && (e.id != 'search_archiwalne'))
        {
            TotalBoxes++;
            if(e.checked) TotalOn++;
        }
    }
    if(TotalBoxes == TotalOn) {
        document.getElementById('search_select_all').checked = true;
    } else {
        document.getElementById('search_select_all').checked = false;
    }
}

function MarkAll(checkb,selid) {
    var val = checkb.checked;
    var opts = $(selid).children;
    for (var i=0; i < opts.length; i++) {
        var opt = opts[i];
        if (opt.children.length) {
            var subopts = opt.children;
            for (var j=0; j < subopts.length; j++) {
                subopts[j].selected = val;
            }
        } else {
            opt.selected = val;
        }
    }
}

/**
 * funkcja ulubionych
 */
function ulubione(obj) {
    var title = document.title;
    var url = document.location;
    if (window.sidebar) {
        window.sidebar.addPanel(title, url, "");
        obj.href = "#";
        return false;
    } else if (window.external) {
        window.external.AddFavorite(url, title);
        obj.href = "#";
        return false;
    } else if (window.opera && window.print) {
        obj.rel = 'sidebar';
        obj.title = title;
        obj.href = url;
        return true;
    }
    return false;
}

/**
 * Funkcja wyświetla obiekt flash w miejscu wywołania konieczna by zachowac
 * walidacje xhtml
 */
function flashFix(o) {
    document.write(o)
}


/**
 * Funkcja pokazuje lub ukrywa zawartosc zakladek w menu glownym panelu
 * administracyjnego
 */
function ShowHideMenuItems(id)
{
    if(document.getElementById(id))
    {
        new Effect.toggle(id, 'blind', {
            duration: 0.5
        });
        if(document.getElementById(id).style.display == 'none')
            sCookie(id, true, 365);
        else
            sCookie(id,'',-1);
    }
}

/**
 * Funkcja pokazuje lub ukrywa menu admina i rozszerza drzewko struktury portalu
 */

var il_new_small_width = new Number();
var cp_new_small_width = new Number();

function ShowHideMainMenu()
{
    var mm_id='cms_left_panel'; //id menu glownego
    var mm = document.getElementById(mm_id); //menu glowne
    var ct = document.getElementById('content'); //content
    var ct_new = $('content'); //content
    var cp = document.getElementById('cms_center_panel'); //panel centralny
    var cp_new = $('cms_center_panel'); //panel centralny
    var kl = document.getElementById('kat_list'); //lista struktury portalu
    var gl = document.getElementById('cms_center_panel_content'); //lista struktury galerii
    var il = document.getElementById('info_list'); //lista struktury informatora
    var il_new = $('info_list');

    if(mm) {
        if(mm.style.display == 'none') {    //jesli lewy panel ukryty, pokazujemy go
            mm.style.display = 'block';
            if(notNull(ct)) ct.style.width = ct.clientWidth - 175 + 'px';
            //if(cp) cp.style.width = cp.clientWidth - 175 + 'px';
            if(notNull(cp_new)) cp_new.style.width = cp_new_small_width+"px";
            if(notNull(kl)) kl.style.width = kl.clientWidth - 178 + 'px';
            if(notNull(gl)) gl.style.width = gl.clientWidth - 178 + 'px';
            //if(il) il.style.width = il.clientWidth - 163 + 'px';
            if(notNull(il_new)) il_new.style.width = il_new_small_width+"px";
        } else {
            if(notNull(cp_new)) cp_new_small_width = cp_new.getWidth()-2;   //odjete paddingi/marginesy
            if(notNull(il_new)) il_new_small_width = il_new.getWidth()-4;   //odjete paddingi/marginesy

            mm.style.display = 'none';  //jesli lewy panel pokazany, ukrywamy go
            
            if(ct) ct.style.width = ct.clientWidth + 175 + 'px';
            if(cp) cp.style.width = cp.clientWidth + 175 + 'px';
            if(kl) kl.style.width = kl.clientWidth + 170 + 'px';
            if(gl) gl.style.width = gl.clientWidth + 170 + 'px';
            if(il) il.style.width = il.clientWidth + 187 + 'px';   
        }
    }
}

/**
 * Nowa wersja funkcji:
 * Funkcja pokazuje lub ukrywa menu admina i rozszerza drzewko struktury portalu
 */
function ShowHideMainMenuNew(divId)
{
    var mm_id='cms_left_panel'; //id menu glownego
    var mm = $(mm_id); //menu glowne

    var mmWidth=mm.getWidth();

    var menu = $(divId);
    var ct = $('content'); //content
    var cp = $('cms_center_panel'); //panel centralny

    if(menu) {
        if(mm) {
            if(mm.visible()) {
                mm.hide();

                var menuWidth=menu.getWidth()+mmWidth;
                var ctWidth=ct.getWidth()+mmWidth;
                var cpWidth=cp.getWidth()+mmWidth;

                menu.clientWidth = menuWidth+"px";
                ct.clientWidth = ctWidth+"px";
                cp.clientWidth = cpWidth+"px";
            } else {
                mm.show();

                var menuWidth=menu.getWidth()-mmWidth;
                var ctWidth=ct.getWidth()-mmWidth;
                var cpWidth=cp.getWidth()-mmWidth;

                menu.clientWidth = menuWidth+"px";
                ct.clientWidth = ctWidth+"px";
                cp.clientWidth = cpWidth+"px";
            }
        }
    }
}

/**
 * Funkcja pokazuje lub ukrywa zaawansowana czesc formularza wyszukiwania
 */
function ShowHideAdvSearch(txtc,txto) {
    var fs = document.getElementById('adv_form');
    var rl = document.getElementById('rollas');
    if(rl && fs) {
        if(fs.style.display == 'none') {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            sCookie('show_search', true, 0);
        } else {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            sCookie('show_search', '', -1);
        }
    }
    new Effect.toggle('adv_form', 'blind', {
        duration: 0.5
    });
}

/**
 * Funkcja do powiekszania i zmniejszania czcionki
 */
var pointer=0;
function FontSize(mode)
{
    var levels=new Array(100,115,130);
    var pointerold=parseInt(gCookie("textsize"));
    if(mode=='up')
    {
        if(pointer<2)pointer++;
    }
    else if(mode=='down')
    {
        if(pointer>0)pointer--;
    }
    else if(mode=='def')
    {
        pointer=0;
    }
    else
    {
        pointer=parseInt(gCookie("textsize"));
        if(isNaN(pointer)) pointer=0;
    }
    var fontval = levels[pointer];
	
    var elements = $$(
        //dodaj klase resize_font np do zajawek
        '.resize_font',
        //elementy tresci tworzonej za pomoca tinymce
        '.content p',
        '.content ._Lista_punktowana',
        '.content ._Lista_numerowana',
        '.content ._Lista_punktowana2',
        '.content ._Lista_numerowana2'
    );
	
    if(elements) {
        for(var i = 0; i < elements.length; i++) {
            elements[i].style.fontSize = fontval + '%';
        }
    }
	
    if (!isNaN(pointer) && pointer != pointerold) {
        sCookie('textsize', '', -1);
        sCookie('textsize', pointer, 1);
    }
}

function FontSizeRestore() {
    var pointer=parseInt(gCookie("textsize"));
    if(isNaN(pointer)) return true;
    FontSize();
}

function SetContrast() {
    var contrast=gCookie("contrast");
    if(contrast == 'true') {
        sCookie('contrast','',0);
    } else {
        sCookie('contrast',true,0);
    }
    location.reload(true);
}


function replEmail(user, site)
{
    document.write('<a href=\"mailto:' + user + '@' + site + '\">');
    document.write(user + '@' + site + '<\/a>');
}
/**
 * Funkcja do wyboru ikonki przy dodawaniu obiektu od strony internauty
 * Drugie wywołanie jest w admin.js
 */
function changeIcon(src,target, self){
    document.getElementById(target).value = src;
    document.getElementById('selected_icon').src = self.src;
}
/**
 * Funkcja pokazuje lub ukrywa prawy panel
 */
function ToggleMap(txtc,txto) {
    var fs = document.getElementById('page_content_right');
    var fshidden = fs.style.display;
    Element.toggle('page_content_right');
    var rl = $('roll');
    var r2 = $('content_center'); //mapa_content_left
    var r3 = $('pg_bgr_top'); //mapa_content_tresc
    var r4 = $('pg_bgr_bottom'); //map
    var r5 = $('map');
    
    if(rl && fs) {
        if(fshidden == 'none') {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            r2.className = 'page_content'; //mapa_content_left
            r3.className = 'page_content_top'; //mapa_content_tresc
            r4.className = 'page_content_bottom'; //mapa
            
            $('page_content_center').style.width = '470px'; //mapa_content_left
            $('content_center').style.width = 'auto'; //mapa_content_tresc
            $('map').style.width = '100%';
            sCookie('show_right_mapa', '', -1);
        } else {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            r2.className += '_big';
            r3.className += '_big';
            r4.className += '_big';
            
            $('page_content_center').style.width = '760px'; //mapa_content_left
            $('content_center').style.width = 'auto'; //mapa_content_tresc
            $('map').style.width = '100%';
            sCookie('show_right_mapa', true, 0);
        }
    }
} 

function ToggleOfidMap(txtc,txto) {
    var fs = document.getElementById('page_content_right');
    var fshidden = fs.style.display;
    Element.toggle('page_content_right');
    var rl = $('roll');
    var r2 = $('content_center');
    var r3 = $('pg_bgr_top');
    var r4 = $('pg_bgr_bottom');
    var r5 = $('map');
    
    if(rl && fs) {
        if(fshidden == 'none') {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            r2.className = 'page_content';
            r3.className = 'page_content_top';
            r4.className = 'page_content_bottom';

            $('page_content_center').style.width = '470px';
            $('content_center').style.width = 'auto';
            $('map').style.width = '100%';
            sCookie('show_right_ofid', '', -1);
        } else {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            r2.className += '_big';
            r3.className += '_big';
            r4.className += '_big';

            $('page_content_center').style.width = '760px';
            $('content_center').style.width = 'auto';
            $('map').style.width = '100%';
            sCookie('show_right_ofid', true, 0);
        }
    }
} 
 
function ToggleGallery(txtc,txto) {
    var fs = document.getElementById('page_content_right');
    var fshidden = fs.style.display;
    Element.toggle('page_content_right');
    var rl = $('roll');
    var r2 = $('content_center');
    var r3 = $('pg_bgr_top');
    var r4 = $('pg_bgr_bottom');
    var r5 = $('content_center_powiazane');
    var r6 = $('pgb_bgr_top');
    var r7 = $('pgb_bgr_bottom');

    if(rl && fs) {
        if(fshidden == 'none') {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            r2.className = 'page_content';
            r3.className = 'page_content_top';
            r4.className = 'page_content_bottom';
            
            if (r5 && r6 && r7) {
                r5.className = 'page_content';
                r6.className = 'page_content_top';
                r7.className = 'page_content_bottom';
                $('content_center_powiazane').style.width = 'auto';
            }

            $('page_content_center').style.width = '470px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_galp', '', -1);
        } else {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            r2.className += '_big';
            r3.className += '_big';
            r4.className += '_big';
            
            if (r5 && r6 && r7) {
                r5.className += '_big';
                r6.className += '_big';
                r7.className += '_big';
                $('content_center_powiazane').style.width = 'auto';
            }

            $('page_content_center').style.width = '760px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_galp', true, 0);
        }
    }
} 

function ToggleIGallery(txtc,txto) {
    var fs = document.getElementById('page_content_right');
    var fshidden = fs.style.display;
    Element.toggle('page_content_right');
    var rl = $('roll');
    var r2 = $('content_center');
    var r3 = $('pg_bgr_top');
    var r4 = $('pg_bgr_bottom');

    if(rl && fs) {
        if(fshidden == 'none') {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            r2.className = 'page_content';
            r3.className = 'page_content_top';
            r4.className = 'page_content_bottom';
            
            $('page_content_center').style.width = '470px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_gali', '', -1);
        } else {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            r2.className += '_big';
            r3.className += '_big';
            r4.className += '_big';

            $('page_content_center').style.width = '760px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_gali', true, 0);
        }
    }
} 
function ToggleMedia(txtc,txto) {
    var fs = document.getElementById('page_content_right');
    var fshidden = fs.style.display;
    Element.toggle('page_content_right');
    var rl = $('roll');
    var r2 = $('content_center');
    var r3 = $('pg_bgr_top');
    var r4 = $('pg_bgr_bottom');

    if(rl && fs) {
        if(fshidden == 'none') {
            rl.className = 'roll';
            rl.innerHTML = txtc;
            r2.className = 'page_content';
            r3.className = 'page_content_top';
            r4.className = 'page_content_bottom';

            $('page_content_center').style.width = '470px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_medi', '', -1);
        } else {
            rl.className = 'roll_sel';
            rl.innerHTML = txto;
            r2.className += '_big';
            r3.className += '_big';
            r4.className += '_big';

            $('page_content_center').style.width = '760px';
            $('content_center').style.width = 'auto';
            sCookie('show_right_medi', true, 0);
        }
    }
}

/**
 * Funkcja do zmiany obrazka captcha jezeli nie da sie odczytac
 */
function reloadCaptcha(url) {
    var random = Math.round(Math.random(0)*1000)+1;
    $("captcha_img").src=url.substr(0, url.length-5)+'/id/'+random+'.html';
}

/**
 * Otwiera nowe okno o podanych wymiarach a w nim podany adres
 */
function NoweOkno(url,szer,wys) {
    if(typeof(szer)!='number') szer=640;
    if(typeof(wys)!='number') wys=360;
    noweOkno = window.open(url, 'okienko', 'menubar=no, toolbar=no, location=no, scrollbars=no, resizable=yes, status=no, width='+szer+', height='+wys+', left=150, top=150');
    noweOkno.focus();
}

function sprawdzAnkiete(params,num,btxt) {
    var ile_pyt = 0;

    for (key in params) {
        if(typeof(params[key]) == 'string') {
            if(trim(params[key]) == '' && key != 'commit') {
                alert(btxt);
                return 0;//pusty input text
            }
        }
        ile_pyt++;
    }
    ile_pyt = ile_pyt-3;//nie wazne 3 parametry, czyli id, vote, i commit bo nie sa pytaniami

    if(ile_pyt != num) {
        alert(btxt);
        return 0;//puste pytanie
    }
    return 1;
}

function trim(str) {
    return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
}
/**
 * Funkcja odczytuje cookie
 * @param N - nazwa cookie
 */
function gCookie(N,x) {
    if((x=document.cookie)&&(N=(';'+x).match(new RegExp('(;| )'+N+'=[^;]+')))) {
        return unescape(N[0].split(/=/g)[1])
    }
}

/**
 * Funkcja ustawia cookie
 * @param N - nazwa cookie
 * @param V - wartosc cookie
 * @param D - czas waznosci w dniach cookie ([0]-wazne do zamkniecia przegladarki, [-1]-usuwa cookie)
 */
function sCookie(N,V,D) {
    document.cookie=N+'='+escape(V)+(D?'; expires='+new Date(+new Date()+D*864e5).toGMTString():'')+'; path=/'
}

if(typeof Position != 'undefined') {
    Position.getWindowSize = function(w)
    {
        var width, height;
        w = w ? w : window;
        this.width = w.innerWidth || (w.document.documentElement.clientWidth || w.document.body.clientWidth);
        this.height = w.innerHeight || (w.document.documentElement.clientHeight || w.document.body.clientHeight);
        return this;
    }
}

//Pokazuje baner popup
function pokaz_baner(id) {
    var aid = 'ads_'+id;
    var iid = 'adsinterval_'+id;
    iid = setInterval("center_element('"+aid+"')", 100);
    document.getElementById(aid).style.display='block';
}

//Ukrywa baner popup
function ukryj_baner(id) {
    document.getElementById('ads_'+id).style.display='none';
    clearInterval('adsinterval_'+id);
    sCookie('popup_'+id, 1, 0);
}

// Centruje poziomo i pionowo element "id"
function center_element(id) {
    var wys = 0;
    var szer = 0;
    var dwys = 0;
    var dszer = 0;
    var offx = 0;
    var offy = 0;
    var left = 0;
    var top = 0;
    if(typeof(window.innerWidth)=='number') {
        szer = window.innerWidth / 2;
        wys = window.innerHeight / 2;
    } else if(document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
        szer = document.documentElement.clientWidth / 2;
        wys = document.documentElement.clientHeight / 2;
    } else if(document.body && (document.body.clientWidth || document.body.clientHeight)) {
        szer = document.body.clientWidth / 2;
        wys = document.body.clientHeight / 2;
    }
    if(typeof(window.pageYOffset)=='number') {
        offx = window.pageXOffset;
        offy = window.pageYOffset;
    } else if(document.body && (document.body.scrollLeft || document.body.scrollTop)) {
        offx = document.body.scrollLeft;
        offy = document.body.scrollTop;
    } else if(document.documentElement && (document.documentElement.scrollLeft || document.documentElement.scrollTop)) {
        offx = document.documentElement.scrollLeft;
        offy = document.documentElement.scrollTop;
    }
    dszer = document.getElementById(id).clientWidth / 2;
    dwys = document.getElementById(id).clientHeight / 2;
    left = Math.round(szer - dszer + offx);
    top = Math.round(wys - dwys + offy);
    document.getElementById(id).style.position = 'absolute';
    document.getElementById(id).style.top = top+'px';
    document.getElementById(id).style.left = left+'px';
}


function checkAllBoxes(checked, className) {
    var boxes = $$('input.'+className+'[type="checkbox"]');
    boxes.each(function(box){
        box.checked = checked;
    })
}

function manageInput(element) {
    element.onfocus = function() {
        if(element.value == element.defaultValue)element.value = "";
    }
    element.onblur = function() {
        if(element.value == "")element.value = element.defaultValue;
    }
}

function copyElement(from_id, to_id, delete_source){
    if($(to_id) && $(to_id)){
        $(to_id).innerHTML = $(from_id).innerHTML;

        if(delete_source){
            $(from_id).remove();
        }
    }
}

function domenaURL() {
    return document.location.protocol+'//'+document.location.host+'/';
}

function notNull(variable) {
    if(variable!=null && variable!=undefined) {
        return true;
    } else {
        return false;
    }
}

function isNull(variable) {
    if(variable==null || variable==undefined) {
        return true;
    } else {
        return false;
    }
}

function checkDefaultPrompt(id,defaultPrompt) {
    var search = $(id);
    if(search.value == defaultPrompt) {
        search.value="";
    }
}