var lines_manager = {
    /**
     * Funkcja tworzy linie ze zbioru punktow przekazanych przez parametr list i nanosi utworzona linie na mape
     * @param {Object} list - iobiekt z lista wspolrzednych
     */

    makeLines: function(list) {
        list.lines._each(function(item) {
            var points = Array();
            item.points._each(function(point){
                points.push(new GLatLng(point.x, point.y));
            });
            var line = new GPolyline(points, item.line_color, item.line_size, 0.7, { mouseOutTolerance: 2 });
            line.id = item.id;
            line.item = item;

            GEvent.addListener(line, 'mouseover', function() { }); //dodane tylko po to zeby kursor zmienial sie na pointer po najechaniu na linie

            GEvent.addListener(line, 'click', function() {
                lines_manager.getLineDescription(line);
            });
            
            gmap_user.lines_array[line.id] = line;
            gmap_user.getMap().addOverlay(line);
        });
    },

    clearLines: function() {
        gmap_user.lines_array._each(function(line) {
            if(line) {
                gmap_user.getMap().removeOverlay(line);
            }
        });
        gmap_user.lines_array = new Array();
    },
    
    /**
     * Funkcja pobiera opis kliknietej linii na mapie, tworzy dymek i wypelnia go pobrana trescia
     * @param {Object} line - GPolyline
     */

    getLineDescription: function (line) {
        new Ajax.Request(line.item.desc, {
            asynchronous: true,
            evalScripts: true,
            method: 'get',
            onLoading : function() {
                var ajax_loader = $('wait');
                if(ajax_loader) {
                    ajax_loader.show();
                }
            },
            onSuccess : function(response) {
                var ajax_loader = $('wait');
                if(ajax_loader) {
                    //trzeba wrzucic opoznienie bo czasami szybciej nastepuje wylaczenie elementu niz wlaczenie
                    Element.hide.delay(0.5, 'wait');
                }
                
                var window_position = new GLatLng(line.item.points[0].x, line.item.points[0].y);
                
                var window_opts = {
                    maxContent: response.responseJSON.pelny_opis,
                    maxTitle: line.item.name
                }

                var window_tabs = new Array();

                for(var tab_name in response.responseJSON.tabs) {
                    var tab = response.responseJSON.tabs[tab_name];
                    window_tabs.push(new GInfoWindowTab(tab.title, tab.content));
                }

                if (typeof (response.responseJSON.tabs) == 'object') { //wersja z zakladkami
                    gmap_user.getMap().openInfoWindowTabsHtml(window_position, window_tabs, window_opts);
                    //gmap_user.getMap().openInfoWindowTabsHtml(window_position, window_tabs, maxopts);
                } else { //wersja bez zakladek
                    gmap_user.getMap().openInfoWindowHtml(window_position, response.responseJSON.pelny_opis, window_opts);
                }
            },

            onFailure: function(response) {
                alert('Błąd: '+response.status+' '+response.statusText)
            }
        });
    }
}



/**
 * @author Alfred Broda
 */

/* Przechowuje współrzędne ostatniego kliknięcia na poligon */ 
var temp_latlng;
var line;

 /* Tworzenie DIVa z zawartością zakłdki do dymku */
function lineTab(item) {
	var ret = document.createElement('div');
	ret.innerHTML = '<b>Linia</b><br/><br/>'+item.op;
	return ret;
} 