var polygons_manager = {
    makePolys: function(list) {
        list.polys._each(function(item) {
            var points = Array();
            item.points._each(function(point){
                points.push(new GLatLng(point.x, point.y));
            });

            var polygon = new GPolygon(points, item.line_color, item.line_size, 0.7, item.fill_color , item.opacity, { mouseOutTolerance: 2 });

            polygon.id = item.id;
            polygon.item = item;
            GEvent.addListener(polygon, 'mouseover', function() { }); //dodane tylko po to zeby kursor zmienial sie na pointer po najechaniu na obszar

            GEvent.addListener(polygon, 'click', function() {
                polygons_manager.getPolygonDescription(polygon);
            });

            gmap_user.polygons_array[polygon.id] = polygon;
            gmap_user.getMap().addOverlay(polygon); //dodanie obszaru na mape
        });
    },

    clearPolys: function() {
        gmap_user.polygons_array._each(function(polygon){
            if (polygon) {
                gmap_user.getMap().removeOverlay(polygon);
            }
        });
        gmap_user.polygons_array = new Array();
    },

    /**
     * Funkcja pobiera opis kliknietego obszaru na mapie, tworzy dymek i wypelnia go pobrana trescia
     * @param {Object} polygon - GPolygon
     */

    getPolygonDescription: function (polygon) {
        new Ajax.Request(polygon.item.desc, {
            asynchronous: true,
            evalScripts: true,
            method: 'get',
            onLoading : function() {
                var ajax_loader = $('wait');
                if(ajax_loader) {
                    ajax_loader.show();
                }
            },
            onSuccess : function(response) {
                var ajax_loader = $('wait');
                if(ajax_loader) {
                    //trzeba wrzucic opoznienie bo czasami szybciej nastepuje wylaczenie elementu niz wlaczenie
                    Element.hide.delay(0.5, 'wait'); 
                }
                
                var window_position = polygon.getBounds().getCenter(); //new GLatLng(polygon.item.points[0], polygon.item.points[0]);

                var window_opts = {
                    maxContent: response.responseJSON.pelny_opis,
                    maxTitle: polygon.item.name
                }

                var window_tabs = new Array();

                for(var tab_name in response.responseJSON.tabs) {
                    var tab = response.responseJSON.tabs[tab_name];
                    window_tabs.push(new GInfoWindowTab(tab.title, tab.content));
                }

                if (typeof (response.responseJSON.tabs) == 'object') { //wersja z zakladkami
                    gmap_user.getMap().openInfoWindowTabsHtml(window_position, window_tabs, window_opts);
                    //gmap_user.getMap().openInfoWindowTabsHtml(window_position, window_tabs, maxopts);
                } else { //wersja bez zakladek
                    gmap_user.getMap().openInfoWindowHtml(window_position, response.responseJSON.pelny_opis, window_opts);
                }
            },

            onFailure: function(response) {
                alert('Błąd: '+response.status+' '+response.statusText)
            }
        });
    }
}
