/**
 * Funkcje obsługujące menu rozwijane informatora/mapy
 * @author Alfred Broda
 * @edited-by Michal Pomaskow
 */

/**
 * Funkcja (ro)zwijająca Listę obiektów
 * @param {Number} id
 * @param {String} get_url
 * @param {String} list_url
 */
function toggleList(id, get_url, list_url) {
    var subcategoryEl = $('subkategoria_'+id);
    var objectsList = $('subkategoria_lista_'+id);

    if (!subcategoryEl) {
        if (showCat) {
            showCat(get_url);
        }
    } else if (subcategoryEl && subcategoryEl.hasClassName('menu_level_sub')) {
        if(objectsList) {
            new Ajax.Request(list_url, {
                onComplete: function() {
                    foldList(objectsList.id);
                    if (showCat) {
                        showCat(get_url);
                    }
                },
                onSuccess: function(ret){
                    if (ret.status == 200) {
                        //$('ikat_' + id).innerHTML = ret.responseText;
                        if(objectsList) {
                            objectsList.update(ret.responseText);
                        }
                        subcategoryEl.removeClassName('menu_level_sub');         //usuwa nazwe klasy css
                        subcategoryEl.addClassName('menu_level_sub_selected');   //dodaje nazwe klasy css
                        //debugger;
                        //subcategoryEl.setAttribute('class', 'menu_level_sub_selected');
                    }
                },
                onFailure: function(){
                    objectsList.update(ret.responseText);
                    return false
                }
            });
        }
    } else if(subcategoryEl) {
        if (hideCat) {
            hideCat(id);
        }
        foldList(objectsList.id);
        subcategoryEl.removeClassName('menu_level_sub_selected');
        subcategoryEl.addClassName('menu_level_sub');
        //subcategoryEl.setAttribute('class', 'menu_level_sub');
    } else if (hideCat) {
        hideCat(id);
    }
} 

function foldList(id) {
    var element = $(id);
    if(element) {
        element.toggle();
        //new Effect.toggle(id, 'blind', {
        //  duration: 0.2
        //});

        if(element.style.display == 'none') {
            sCookie(id,'',-1);
        } else {
            sCookie(id, true, 365);
        }
    }
}

function showList(id) {
    if($(id)) {
        $(id).show();
    }
}

function checkToUnfold(id) {
    if($(id)) {
        if($(id).style.display == 'none') {
            return true;
        } else {
            return false;
        }
    }

    return false;
}

/**
 * Funkcja uruchamiająca funkcję dodania do ulubionych przeglądarki
 * @param {String} title
 * @author Bartosz "BTM" Szczeciński
 * @author Przemysław Wesołowski
 * @author Alfred Broda
 * 
 */
function ulubione(obj)
{
	var title = document.title;
	var url = document.location;
	if (window.sidebar)
	{
		window.sidebar.addPanel(title, url,"");
		obj.href="#";
		return false;
	}
	else if (window.external)
	{
		window.external.AddFavorite(url, title);
		obj.href="#"; 
		return false;
	}
	else if (window.opera && window.print)
	{
		obj.rel = 'sidebar';
		obj.title = title;
		obj.href = url;
		return true;
	}
	return false;
}
