/**
 * @author Alfred Broda
 */

/* Funkcje pomocnicze */
function rand ( n ) {
    return ( Math.floor ( Math.random ( ) * n + 1 ) );
}

function pause(millis) {
    var date = new Date();
    var curDate = null;
    do {
        curDate = new Date();
    }
    while(curDate-date < millis)
}

function isset (varname) {
    return(typeof(varname)!='undefined');
}

Array.prototype.in_array = function(p_val) {
    for(var i = 0, l = this.length; i < l; i++) {
        if(this[i] == p_val) {
            return true;
        }
    }
    return false;
}

/* ------------- */

var allcats = Array();
var allids = Array();

function showCat(url) {
    url = url.replace('.html','/rand/'+rand(1000)+'.html');
    new Ajax.Request(url, {
        asynchronous :true,
        evalScripts :false,
        method :'get',
        onComplete : function(request, json) {
            Element.hide('wait');
        },
        onLoading : function(request, json) {
            Element.show('wait');
        },
        onSuccess : function(response) {
            if (response.status == 200) {
                var list = String(response.responseText);
                list = list.evalJSON();
                var cats = Object.values(list.cats);
                cats._each( function(list) {
                    if (typeof (list) == "object") {
                        allcats[list.id] = list;
                    }
                });
                redrawCats();
            /*
				 * var ne = new GPoint(list.maxx, list.maxy); var sw = new
				 * GPoint(list.minx, list.miny); var mid = new
				 * GLatLng(list.posn[0], list.posn[1]); var bounds = new
				 * GLatLngBounds(sw, ne); var z =
				 * map.getBoundsZoomLevel(bounds); map.setCenter(mid, z);
				 */
            }
        }
    });
}

function hideCat(cat) {
    removed = allcats[cat];
    allcats.splice(cat, 1);
    redrawCats();

}

function redrawCats() {
    clearMarkers();
    clearPolys();
    clearLines();
    allcats._each( function(cat) {
        if (typeof (cat) == 'object') {
            if (typeof (cat.places) == 'object') {
                makeMarkers(cat);
            }

            if (typeof (cat.polys) == 'object') {
                makePolys(cat);
            }

            if (typeof (cat.lines) == 'object') {
                makeLines(cat);
            }
        }
    });
}

/**
 * Pokazuje opis klikniętego markera wyciągając go z bazy AJAXem
 *
 * @param {Object} feature Objekt markera
 * @param {String} junk dowolny tekst
 *
 */

function get_opis(feature, junk) {
    //alert(junk);
    selected = feature;
    if (marker && typeof (marker) == 'object' && feature.attributes.desc) {
        new Ajax.Request(feature.attributes.desc, {
            asynchronous :true,
            evalScripts :false,
            method :'get',
            onComplete : function(request, json) {
                Element.hide('wait');
            },
            onLoading : function(request, json) {
                Element.show('wait');
            },
            onSuccess : function(res) {
                var temp = res.responseText;
                var tabs = Array();

                var full = temp.slice(temp.match("<!--full-start").index,temp.match("<!--end-->").index);


                /* zakładki dymka */
                var start_end = Array();
                var opis = "";
                var start = 0;
                var end = 0;
                start_end = ["<!--begin", "<!--opis-end", "<!--loka-end", "<!--srch-end", "<!--trak-end", "<!--full-start" ];

                /* Tniemy odpowiedź na bloki */
                var cont;
                if (temp.match(start_end[0])) {

                    //var head = temp.slice(0, temp.match(start_end[0]).index);
                    var i = 0;
                    while ( i < start_end.length-1 ) {
                        var startt = start_end[i];
                        start = temp.match(start_end[i]);
                        var endt = start_end[i+1];
                        end = temp.match(start_end[i+1]);
                        if ( start && end ) {
                            opis = temp.slice(temp.match(start).index, temp.match(end).index);
                            var content = opis.slice(opis.match("start-->").index+8);
                            if (content.strip() != "") {
                                start = opis.match(start_end[i]).index+start_end[i].length;
                                end = opis.match("start-->").index;
                                //tytul = opis.slice(start, end);
                                tabs.push(opis);
                            }
                            start = end = 0;
                        }
                        i++;
                    }
                    cont = tabs[0];
                } else {
                    cont = temp;
                }

                // przygotowujemy zakotwiczony Popup
                var anchor;

                if (selected.icon) {
                    anchor = selected.icon;
                } else {
                    if (!selected.px && selected.geometry) {
                        selected.px = selected.geometry.getCentroid();
                    }
                    anchor = {
                        size: new OpenLayers.Size(1,1),
                        offset: selected.px
                    };
                }
                
                var pop = new OpenLayers.Popup('popup_'+selected.attributes.id,
                    selected.lonlat,
                    new OpenLayers.Size(300,200),
                    cont,
                    //anchor,
                    true);
                pop.panMapIfOutOfView = true;
                pop.px = selected.px;

                pop.tabs = tabs;
                pop.full = full;
                //this.full = full;

                pop.maximize = function () {
                    var map_size = map.getSize();
                    var popw = map_size.w - 90;
                    var poph = map_size.h - 10;
                    var lonlat = map.getLonLatFromViewPortPx(new OpenLayers.Pixel(45,5));
                    var pop_full = new OpenLayers.Popup.AnchoredBubble('full_text',
                        lonlat,
                        new OpenLayers.Size(popw,poph),
                        this.full,
                        {
                            size: new OpenLayers.Size(1,1),
                            offset: selected.px
                        },
                        false);
                    pop_full.closeOnMove = true;
                    pop_full.autoSize = true;
                    map.addPopup(pop_full,true);
                    popup = pop_full;
                    this.destroy();
                }

                map.addPopup(pop, true);
                popup = pop;
            }
        });
    }
}
