/**
 * Funkcje poligonów
 *
 * @author Alfred Broda
 */

var lines = true
var alllines = Array();

function makeLines(list) {
    var num = alllines.size();

    list.lines._each(function(item) {
        var n = 0;
        var points = Array();
        item.points._each(function(point){
            point = new OpenLayers.LonLat(point.y, point.x);
            if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
                point.transform(epsg4326,map.getProjectionObject());
            }
            points[n] = new OpenLayers.Geometry.Point(point.lon, point.lat);
            n++;
        });

        var geometry = new OpenLayers.Geometry.LineString(points);
        //var geometry = new OpenLayers.Geometry.LinearRing(points);
        //geometry = new OpenLayers.Geometry.Polygon(geometry);
        var style = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);
        //style.fillOpacity = item.opacity;
        //style.fillColor = item.fill_color
        style.strokeOpacity = item.opacity;
        style.strokeColor = item.line_color;
        style.strokeWidth = item.line_size;

        var polygon = new OpenLayers.Feature.Vector(geometry, item, style);
        
        if (allids[item.id] != true) {
            allids[item.id] = true;
            alllines.push(polygon);
            num++;
        }
    });
    redrawLines();
}

function deleteLine(id) {
    alllines.splice(id, 1);
    allids[item.id] = false;
    redrawMarkers();
}

function clearLines() {
    alllines._each(function(item) {
        allids[item.attributes.id] = false;
    });
    alllines = Array();
    redrawLines();
}

function redrawLines() {
    lineLayer.removeFeatures(lineLayer.features);
    lineLayer.addFeatures(alllines);
}

function startLine(points) {
    for(var key in drawControls) {
        drawControls[key].deactivate();
    }
    drawControls['line'].featureAdded = function(feat) {
        select('hand_b');
        var map_points = feat.geometry.getVertices();
        points_save=Array();
        map_points._each(function(mpoint){
            if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
                mpoint.transform(map.getProjectionObject(),epsg4326);
            }
            points_save.push({
                y: mpoint.x,
                x: mpoint.y
                });
        });

        drawControls['line'].deactivate();
    }
    drawControls['line'].activate();
}
