/**
 * Funkcje markerów
 *
 * @author Alfred Broda
 */

var markers = true;
var allmarkers = Array();

function getIcon(image, size) {
    var ico = null;

    if (!size) {
        size = 22;
    }
    if (image) {
        ico = basedir + size + "x" + size + "/" + image;
    }
    size = new OpenLayers.Size(32,32);
    ico = new OpenLayers.Icon(ico,size);
    return ico;
}

function makeMarkers(list) {
    //allmarkers = Array();
    var point;
    var icon;
    list.places._each( function(item) {
        point = new OpenLayers.LonLat(item.posn[1], item.posn[0]);
        if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
            point.transform(epsg4326, map.getProjectionObject());
        }
        if (typeof(edit)!='undefined' && edit) {
            var tabs = edform(item);
            var gtabs = Array();
            var n = 0;
            tabs._each( function(tab) {
                //gtabs[n] = new GInfoWindowTab(tab.label, tab.content);
                gtabs[n] = tab.content;
                n++;
            });
            alldesc[item.id] = gtabs;
            /*			GEvent.addListener(marker, "infowindowbeforeclose", function() {
				alert("Zmiany nie zostaną zapisane!");
			}); */
            item.mask = 0;
        } else {
            if (item.icon == "default.png")
                var ico = item.dicon;
            else
                var ico = item.icon;
        }
        if (item.mask == 1) {
            icon = getIcon(item.dicon, 16);
            var opts = {
                icon :icon,
                title :item.sname,
                transparent :item.dicon
            };
        /*			var mark2 = new GMarker(posn, opts);
			GEvent.addListener(mark2, "mouseover", function() {
				mark2.setImage(basedir + "32x32/" + item.icon);
			});
			GEvent.addListener(mark2, "mouseout", function() {
				if (map.getZoom() < item.izmax)
					mark2.setImage(basedir + "16x16/" + item.dicon);
			});
			// FIXME: Możemy zduplikować id? Warto jakieś jednak mieć...
			mark2.id = item.id;
			// marker ma się pojawiać o poziom wyżej
			mark2.izmin = item.izmin;
			mark2.izmax = item.izmax - 1;
			var desc = document.createElement('div');
			desc.innerHTML = alldesc[item.id].innerHTML;
			desc.className = 'gpopup';
			mark2.bindInfoWindow(desc, maxopts);
			// Drugi marker będzie 'niżej' niż ten
			item.izmin = item.izmax;
			item.izmax = 17;
			var num = allmarkers.push(mark2); */
        } else {
            // jeżeli nie maskujemy to zapewne chcemy mieć markery w pełnym zakresie
            item.izmax = 17;
        }
        icon = getIcon(item.icon, 32);

        var marker = new OpenLayers.Marker(point,icon);
        /*marker.latlng = point;
        marker.id = item.id;
        marker.item = item;
        marker.izmin = item.izmin;
        marker.izmax = item.izmax;
        marker.mask = item.mask; */
        /*
		 * var desc = document.createElement('div'); var temp = opis;
		 * desc.innerHTML = opis; desc.className = 'gpopup';
		 */
        marker.attributes = item;

        if (allids[item.id] != true) {
            allids[item.id] = true;
            allmarkers.push(marker);
        }
    });
    redrawMarkers();
}

function redrawMarkers() {
    pointLayer.clearMarkers();
    allmarkers._each( function(marker) {
        pointLayer.addMarker(marker);
    });
}

function deleteMarker(id) {
    allmarkers.splice(id, 1);
    redrawMarkers();
}

function clearMarkers() {
    allmarkers._each(function(item) {
        allids[item.attributes.id] = false;
    });
    allmarkers = Array();
    redrawMarkers();
}
