
var map, layer, gml, marker, popup, getter, selected;
var edit = false;
var maps = Array();
var epsg4326;
var pointLayer;
var polygonLayer;
var lineLayer;
var drawControls;
var selectControls;

OpenLayers.Lang.setCode("pl");

function init() {
    if (zoomify_enabled == true) {
        var zoomify = new OpenLayers.Layer.Zoomify(
            "Zoomify",
            base+'images/map_tiles/zoomify/',
            new OpenLayers.Size(zfy_w,zfy_h));

        var options = {
            controls: [],
            maxExtent: new OpenLayers.Bounds(0, 0, zfy_w, zfy_h),
            maxResolution: Math.pow(2, zoomify.numberOfTiers-1 ),
            numZoomLevels: zoomify.numberOfTiers,
            units: 'pixels'
        };

        map = new OpenLayers.Map('map',options);

        maps.push(zoomify);

        //map.addControl(new OpenLayers.Control.MousePosition());
        map.addControl(new OpenLayers.Control.PanZoomBar());
        map.addControl(new OpenLayers.Control.MouseDefaults());
        map.addControl(new OpenLayers.Control.KeyboardDefaults());

    } else {
        epsg4326 = new OpenLayers.Projection("EPSG:4326");

        map = new OpenLayers.Map('map',{
            maxResolution: 800/600/16,
            numZoomLevels: 19,
            units: 'm',
            projection: new OpenLayers.Projection("EPSG:900913"),
            displayProjection: epsg4326,
            controls: [ new OpenLayers.Control.Navigation(), new OpenLayers.Control.PanZoomBar() ]
        });

        if (map_types.in_array('karto')) {
            var mapKarto = new OpenLayers.Layer.OSM("Kartograficzna",
                [ base+"/tile.php?type=kartograficzna&zoom=${z}&lat=${x}&lng=${y}.png" ],
                {
                    numZoomLevels: 17,
                    'buffer':0,
                    transitionEffect: 'resize',
                    attribution: "Data by <a target='_blank' href='http://www.conceptintermedia.pl/'>ConceptIntermedia</a>"
                });
            maps.push(mapKarto);
        }

        if (map_types.in_array('lotnicza')) {
            var mapLot = new OpenLayers.Layer.OSM("Kartograficzna",
                [ base+"/tile.php?type=lotnicza&zoom=${z}&lat=${x}&lng=${y}.png" ],
                {
                    numZoomLevels: 17,
                    'buffer':0,
                    transitionEffect: 'resize',
                    attribution: "Data by <a target='_blank' href='http://www.conceptintermedia.pl/'>ConceptIntermedia</a>"
                });
            maps.push(mapLot);
        }

        if (map_types.in_array('osm')) {
            mapOSM = new OpenLayers.Layer.OSM("OpenStreetMap");
            maps.push(mapOSM);

            mapOCM = new OpenLayers.Layer.OSM("OpenCycleMap",
                [
                "http://andy.sandbox.cloudmade.com/tiles/cycle/${z}/${x}/${y}.png"
                ],
                {
                    numZoomLevels: 19,
                    'buffer':0,
                    transitionEffect: 'resize',
                    attribution: "Data by Andy"
                });
            maps.push(mapOCM);
        }

        if (map_types.in_array('ump')) {
            mapUMP = new OpenLayers.Layer.OSM("UMP@Mapnik",
                [
                "http://1.tiles.ump.waw.pl/ump_tiles/${z}/${x}/${y}.png",
                "http://2.tiles.ump.waw.pl/ump_tiles/${z}/${x}/${y}.png",
                "http://3.tiles.ump.waw.pl/ump_tiles/${z}/${x}/${y}.png"
                ],
                {
                    numZoomLevels: 19,
                    'buffer':0,
                    transitionEffect: 'resize',
                    attribution: "Data by <a target='_blank' href='http://ump.waw.pl/'>UMP-pcPL</a>+<a target='_blank' href='http://www2.jpl.nasa.gov/srtm/'>SRTM</a><br/><img src='http://tiles.ump.waw.pl/lib/status.png'/>"
                });
            maps.push(mapUMP);
        }
    
        if (map_types.in_array('gmaps')) {
            /*var g_street = new OpenLayers.Layer.Google("Google Streets", {
            visibility: false,
            type: G_NORMAL_MAP,
            sphericalMercator: true
        });
        maps.push(g_street);
        
        var g_sat = new OpenLayers.Layer.Google("Google Satellite", {
            visibility: false,
            type: G_SATELLITE_MAP,
            sphericalMercator: true
        });
        maps.push(g_sat); */

            var g_hybrid = new OpenLayers.Layer.Google("Google Hybryda", {
                visibility: false,
                type: G_HYBRID_MAP,
                transitionEffect: 'resize',
                sphericalMercator: true
            });
            maps.push(g_hybrid);
        }

        map.addControl(new OpenLayers.Control.LayerSwitcher());
    } 

    polygonLayer = new OpenLayers.Layer.Vector("Obszary");
    maps.push(polygonLayer);

    lineLayer = new OpenLayers.Layer.Vector("Linie");
    maps.push(lineLayer);

    pointLayer = new OpenLayers.Layer.Markers("Punkty");
    /*
     *  Podpinamy tą warstwę pod Control.SelectFeature(),
     *  więc musi wybierać markery jak wektorowa
     */
    pointLayer.isVector = true;
    pointLayer.renderer = new OpenLayers.Renderer.Dummy();
    pointLayer.drawFeature = function(ju,nk) {};
    pointLayer.selectedFeatures = Array();
    pointLayer.getFeatureFromEvent = function (event) {
        // get lonlat
        var target = event.xy;
        for (var index = 0; index < this.markers.length; ++index) {
            var marker = this.markers[index];
            if (marker.isDrawn()) {
                marker.px = map.getPixelFromLonLat(marker.lonlat);
                marker.tl = marker.px.x+marker.icon.offset.x;
                marker.tr = marker.px.x-marker.icon.offset.x;
                marker.bl = marker.px.y+marker.icon.offset.y;
                marker.br = marker.px.y-marker.icon.offset.y;
                if ((marker.tl <= target.x)
                    && (marker.tr >= target.x)
                    && (marker.bl <= target.y)
                    && (marker.br >= target.y)
                    ) {
                    marker.layer = pointLayer;
                    return marker;
                }
            }
        }
        return null;
    }
    maps.push(pointLayer);

    map.addLayers(maps);
    map.setBaseLayer(maps[0]);
    
    getter = new OpenLayers.Control.SelectFeature([  pointLayer, polygonLayer, lineLayer ],{
        onSelect: function(feature) {
            if (isset(feature)) {
                get_opis(feature,'select');
            }
        }
    });
    
    map.addControl(getter);

    //map.addControl(new OpenLayers.Control.MousePosition());

    if (edit) {
        drawControls = {
            point: new OpenLayers.Control.Click(),
            line: new OpenLayers.Control.DrawFeature(lineLayer,
                OpenLayers.Handler.Path),
            polygon: new OpenLayers.Control.DrawFeature(polygonLayer,
                OpenLayers.Handler.Polygon)
        }
    } else {
        getter.activate();
    }

    for(var key in drawControls) {
        map.addControl(drawControls[key]);
    //drawControls[key].activate();
    }

    map.checkResize = function () {}
    map.clearOverlays  = function () {}
    map.removeOverlay  = function () {}
    map.getInfoWindow = function () {
        return popup;
    }
    map.getMaximumZoom = function() {
        return map.baseLayer.numZoomLevels;
    }

    if (zoomify_enabled) {
        if (actz && actx && acty) {
            map.setCenter(new OpenLayers.LonLat(acty, actx),Number(actz));
            if (actz > map.getMaximumZoom()) alert('Niepoprawny zoom, maksimum to '+map.getMaximumZoom());
        } else{
            map.zoomToMaxExtent();
        }
    } else {
        if (edit) {
            wskaz(actx,acty,actz);
        } else {
            wskaz(defx,defy,defz);
        }
    }

//initVectorLayer();
}

/* Funkcje Mapy */
function getMapCenter() {
    if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
        return map.getCenter().clone().transform(map.getProjectionObject(), epsg4326);
    } else {
        return map.getCenter();
    }
}

function mapChange(type) {
    map.setBaseLayer(maps[type]);
}

function wskaz(y,x,z) {
    if (isset(marker) && isset(marker.destroy)) {
        pointLayer.removeMarker(marker);
        marker.destroy();
    }

    var point = new OpenLayers.LonLat(x,y);
    if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
        point.transform(epsg4326, map.getProjectionObject());
    }
    var size = new OpenLayers.Size(32,32);

    var icon = new OpenLayers.Icon(basedir+'32x32/default.png',size);

    map.setCenter(point,Number(z));
    // Umieszczenie markera
    marker = new OpenLayers.Marker(point, icon);
    marker.attributes = {};
    //mark.attributes[name] = 'Punkt';
    pointLayer.addMarker(marker);
}

var mPrinted = false;

function print_map() {
    if (!mPrinted) {
        $('map_print').appendChild($('map').childNodes[0].childNodes[0]);
        $('map_print').style.width = $('map').clientWidth+"px";
        $('map_print').style.height = $('map').clientHeight+"px";
        if ($('map_print').style.display == 'none') {
            $('map_print').show();
        }
        mPrinted = true;
        print();
        setTimeout(function() {
            //alert('Zakończono drukowanie');
            print_map();
        }, 100);
    } else {
        //Element.remove($('map_print').childNodes[0]);
        $('map').childNodes[0].appendChild($('map_print').childNodes[0]);
        if ($('map_print').style.display != 'none') {
            $('map_print').hide();
        }
        mPrinted = false;
    }
}

function zoomifyEnable() {
    if (zoomify_enabled == false) {
        zoomify_enabled = true;
        map.destroy();
        init();
    }
}

function zoomifyDisable() {
    if (zoomify_enabled == true) {
        zoomify_enabled = false;
        map.destroy();
        init();
    }
}

/* Wyłapywanie kliknięć na mapie - do admina */
OpenLayers.Control.Click = OpenLayers.Class(OpenLayers.Control, {
    defaultHandlerOptions: {
        'single': true,
        'double': false,
        'pixelTolerance': 0,
        'stopSingle': false,
        'stopDouble': false
    },

    initialize: function(options) {
        this.handlerOptions = OpenLayers.Util.extend(
        {}, this.defaultHandlerOptions
            );
        OpenLayers.Control.prototype.initialize.apply(
            this, arguments
            );
        this.handler = new OpenLayers.Handler.Click(
            this, {
                'click': found
            }, this.handlerOptions
            );
    }
});

OpenLayers.Renderer.Dummy = OpenLayers.Class(OpenLayers.Renderer, {
    defaultSymbolizer: {},

    initialize: function(options) {
        OpenLayers.Renderer.prototype.initialize.apply(
            this, arguments
            );
        this.supported = function(){
            return true;
        }
    }
});
