/**
 * Funkcje poligonów
 *
 * @author Alfred Broda
 */

var polys = true
var allpolys = Array();

function makePolys(list) {
    var num = allpolys.size();

    list.polys._each(function(item) {
        var n = 0;
        var points = Array();
        item.points._each(function(point){
            point = new OpenLayers.LonLat(point.y, point.x);
            if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
                point.transform(epsg4326,map.getProjectionObject());
            }
            points[n] = new OpenLayers.Geometry.Point(point.lon, point.lat);
            n++;
        });
        
        //var geometry = new OpenLayers.Geometry.LineString(points);
        var geometry = new OpenLayers.Geometry.LinearRing(points);
        geometry = new OpenLayers.Geometry.Polygon(geometry);
        var style = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);
        style.fillOpacity = item.opacity;
        style.fillColor = item.fill_color
        style.strokeColor = item.line_color;
        style.strokeWidth = item.line_size;

        var polygon = new OpenLayers.Feature.Vector(geometry, item, style);

        if (allids) {
            allids[item.id] = true;
            allpolys.push(polygon);
            num++;
        }
    });
    redrawPolys();
}

function deletePoly(id) {
    allpolys.splice(id, 1);
    redrawPolys();
}

function clearPolys() {
    allpolys._each(function(item) {
        allids[item.attributes.id] = false;
    });
    allpolys = Array();
    redrawPolys();
}

function redrawPolys() {
    polygonLayer.removeFeatures(polygonLayer.features);
    polygonLayer.addFeatures(allpolys);
}

function startShape(points) {
    for(var key in drawControls) {
        drawControls[key].deactivate();
    }

    drawControls['polygon'].featureAdded = function(feat) {
        select('hand_b');
        var map_points = feat.geometry.getVertices();
        points_save=Array();
        map_points._each(function(mpoint){
            if (isset(epsg4326) && (map.getProjectionObject().projCode != epsg4326.projCode)) {
                mpoint.transform(map.getProjectionObject(),epsg4326);
            }
            points_save.push({
                y: mpoint.x,
                x: mpoint.y
                });
        });
        drawControls['polygon'].deactivate();
    }
    drawControls['polygon'].activate();
}
