/**
 * $Id: editor_plugin_src.js 201 2007-02-12 15:56:56Z spocke $
 *
 * @author Moxiecode
 * @copyright Copyright � 2004-2008, Moxiecode Systems AB, All rights reserved.
 */

(function() {

	tinymce.create('tinymce.plugins.WstawAnkiete', {
		/**
		 * Initializes the plugin, this will be executed after the plugin has been created.
		 * This call is done before the editor instance has finished it's initialization so use the onInit event
		 * of the editor instance to intercept that event.
		 *
		 * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
		 * @param {string} url Absolute URL to where the plugin is located.
		 */
		init : function(ed, url, type, win) {
                        var title = '';
                        var button_title = '';
                        switch(ed.settings.language) {
                            case "pl":
                                 title = 'Wybierz ankietę do wstawienia';
                                 button_title = 'Wstaw ankietę';
                            break;

                            case "en":
                            default:
                                title = 'Select survey to insert';
                                button_title = 'Insert survey';
                            break;
                        }

			// Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand('mceExample');
			ed.addCommand('anktcmd', function() {
				ed.windowManager.open({
					file : url+'/../../../../admin.php/ankiety/wybierz.html',
					width : 400,
					height : 520,
					inline : 1,
					title : title
				}, {
					plugin_url : url, // Plugin absolute URL
					window : win
				});
			});

			// Register example button
			ed.addButton('ankiety', {
				title : button_title,
				image : url+'/ankiety_button.png',
				cmd : 'anktcmd'
			});
		},

		/**
		 * Creates control instances based in the incomming name. This method is normally not
		 * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
		 * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
		 * method can be used to create those.
		 *
		 * @param {String} n Name of the control to create.
		 * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
		 * @return {tinymce.ui.Control} New control instance or null if no control was created.
		 */
		createControl : function(n, cm) {
			return null;
		},

		/**
		 * Returns information about the plugin as a name/value array.
		 * The current keys are longname, author, authorurl, infourl and version.
		 *
		 * @return {Object} Name/value array containing information about the plugin.
		 */
		getInfo : function() {
			return {
				longname : 'AnkietyPlugin',
				author : 'R.G.',
				authorurl : '',
				infourl : '',
				version : "1.0"
			};
		}
	});

	// Register plugin
	tinymce.PluginManager.add('ankiety', tinymce.plugins.WstawAnkiete);
})();