/*
 * Funkcje pomocnicze drzewka
 *
 * @package sfTreePlugin
 * @author Alfred Broda
 */

function togglePlus(elem) {
        var cls = elem.className;
        if (cls.match('plus')) {
            elem.className = cls.replace('plus','minus');
        } else if (cls.match('minus')) {
            elem.className = cls.replace('minus','plus');
        }
}

// http://code.activestate.com/recipes/414334-pass-javascript-arrays-to-php/
//
// This converts a javascript array to a string in PHP serialized format.
// This is useful for passing arrays to PHP. On the PHP side you can
// unserialize this string from a cookie or request variable. For example,
// assuming you used javascript to set a cookie called "php_array"
// to the value of a javascript array then you can restore the cookie
// from PHP like this:
//    <?php
//    session_start();
//    $my_array = unserialize(urldecode(stripslashes($_COOKIE['php_array'])));
//    print_r ($my_array);
//    ?>
// This automatically converts both keys and values to strings.
// The return string is not URL escaped, so you must call the
// Javascript "escape()" function before you pass this string to PHP.

function js_array_to_php_array (a)
{
    var a_php = "";
    var total = 0;
    for (var key in a)
    {
        ++ total;
        a_php = a_php + "s:" +
                String(key).length + ":\"" + String(key) + "\";s:" +
                String(a[key]).length + ":\"" + String(a[key]) + "\";";
    }
    a_php = "a:" + total + ":{" + a_php + "}";
    return a_php;
}

/**
 * http://milesj.me/snippets/javascript/slugify
 *
 * Transform text into a URL slug: remove non alnum
 * @param string text
 */
function slugify(text) {
	text = text.replace(/[^-a-zA-Z0-9,&\s]+/ig, '');
	text = text.replace(/[-\s]+/gi, "_");
    text = text.replace(/^_*|_*$/g, '');
	return text;
}


function updateParentForm(key, link, rule, field, innerName)
{
    var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi;

    innerName = innerName.replace(tags, '');

    link = link.replace('%25%25KLUCZ%25%25', key);
    link = link.replace('%25%25JUNK%25%25', slugify(innerName.toLowerCase()));

    rule = rule.replace('%25%25KLUCZ%25%25', key);
    rule = rule.replace('%25%25JUNK%25%25', slugify(innerName.toLowerCase()));

    var json_data_object = eval("(" + rule + ")");
    rule = js_array_to_php_array(json_data_object);

    if (document.is_field_empty) {
        $(field+'_title').value = innerName;
    }
    $(field+'_link').value = link;
    $(field+'_rule').value = rule;

    $('link') ? $('link').innerHTML = link : null;
    $('rule') ? $('rule').innerHTML = rule : null;

    return false;
}

