/**
	zoomy v 2.0.1 27.01.2009
	Copyright (c) 2008 Filippo Buratti; info [at] cssrevolt.com [dot] com; http://www.filippoburatti.net/

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE.
*/
var zoomyDebug = false;
var mouseOverZoomyImg = false;
var relatedZoomyElement;

var Zoomy = Class.create({

    initialize: function(element, options) {

    //check if link is correctly build
    if($(element).childElements().length == 0) return true;

    $(element).childElements().each(function(el){
        if(el.nodeName.toUpperCase() != 'IMG')return true;
    });
   
   //and if it leads to an image
    var images = new Array('bmp', 'jpg', 'jpeg', 'gif', 'png');
    var correctLink = false;
   
    images.each(function(val){
        if(zoomyDebug)console.log(element.href+' leads to picture? : '+ element.href.include(val));
        if(element.href.toUpperCase().include(val.toUpperCase()))correctLink = true;
    });
    
    if(!correctLink)return true;
    
        this.options = {
            appearDuration: 0.5,
            draggable:false,
            hideCaption:false
        }
        Object.extend(this.options, options || {});

        this.element  = $(element);

        this.addEvent = this.prepareZoom.bindAsEventListener(this);
        this.element.observe("mouseover", this.addEvent);
        this.element.onclick = function(){
            return false;
        }

        Event.observe(document, 'mousemove', function(event) {
            
            if($(relatedZoomyElement)){
            var x = Event.pointerX(event);
            var y = Event.pointerY(event);

            var off = Element.cumulativeOffset($(relatedZoomyElement));
            var dim = Element.getDimensions($(relatedZoomyElement));
            
            if(Position.within($(relatedZoomyElement), x, y) || Position.within($('zoomy'), x, y)){
                 if(zoomyDebug)console.log('Mouse over zoomy img');
                 mouseOverZoomyImg = true;
            }else{
                if($("zoomy"))$("zoomy").hide();
                 if($("zoomyoverlay"))$("zoomyoverlay").hide()
                if(zoomyDebug)console.log('Mouse NOT over zoomy img');
                mouseOverZoomyImg = false;
                relatedZoomyElement = null;
            }
            }
            if(!mouseOverZoomyImg && $('zoomy'))$('zoomy').remove();

        });

    },
  
    prepareZoom: function(event) {
        
	if(mouseOverZoomyImg)return true;
        relatedZoomyElement = event.element();
        Event.stop(event);

        /*new Effect.Opacity(this.element, {
            from: 1.0,
            to: 0.3,
            duration: 0.5
        });*/
		
        var zClose		= "<span id='close' title='Zamknij'></span>";
        var zSrc 		= this.element.readAttribute('href');
        var zTitle		= this.element.readAttribute('title') || '' ;
        var zCaption 	= (!this.options.hideCaption || this.options.draggable) ? "<p>"+ zTitle + zClose +"</p>" : "";
			
        if ($('zoomy')) {
            this.hideZoom();
        }
			
        $(document.body).insert("<div id='zoomy'>"+ zCaption +"<img src='"+ zSrc +"' alt='"+ zTitle +"' /></div>");
				
        this.mouseX = Event.pointerX(event);
        this.mouseY = Event.pointerY(event);
							
        var imgPreloader = new Image();			
        imgPreloader.onload = (function(){
            if($('zoomy')){
                this.showOverlay();
                this.showZoom();
            }
        }).bindAsEventListener(this);
        imgPreloader.src =  zSrc;
				
        $('zoomy').hide();
			
    },
	
    showZoom: function() {
		
        var zoomDim 	= $('zoomy').getDimensions();
        this.zWidth  	= zoomDim.width;
        this.zHeight 	= zoomDim.height;
		
        if($('zoomy'))$('zoomy').setStyle({
            width: '1px',
            height: '1px',
            position: 'absolute',
            top: this.mouseY + 'px',
            left: this.mouseX+'px'
        });

		
        var globalDim	= document.viewport.getDimensions();
        var wWidth		= globalDim.width;
        var wHeight		= globalDim.height;
        var yScroll 	= document.viewport.getScrollOffsets().top;
		
		
        //var newTop      = Math.floor((wHeight/2) - (this.zHeight/2) + yScroll);
        var newTop      = 20 + yScroll;
        var newLeft     = Math.floor((wWidth/2) - (this.zWidth/2));

        var moveX     = -(this.mouseX - newLeft);
        var moveY     = -(this.mouseY - newTop);
		
        new Effect.Parallel([
            new Effect.Appear('zoomy', {
                sync:true
            }),
            new Effect.Move('zoomy', {
                x: moveX,
                y: moveY,
                sync: true
            }),
            new Effect.Morph('zoomy', {
                style: {
                    width: this.zWidth + 'px',
                    height: this.zHeight + 'px'
                },
                sync: true
            })
            ],  {
                duration: this.options.appearDuration,
                afterFinish: function() {
                    if($('zoomy'))this.setZoom();
                }.bind(this)
            });
		
		
    },
	
    hideZoom: function() {
	
        $("zoomy").remove();
        this.hideOverlay();
        mouseOverZoomyImg = false;
        relatedZoomyElement = null;
		
    },
	
    setZoom: function() {
		
        /*new Effect.Opacity(this.element, {
            from: 0,
            to: 1,
            duration: 0.5
        });*/
        if (this.options.draggable){
            new Draggable('zoomy');
        }
        $('zoomy').observe('click',function(event) {
            this.hideZoom();
        }.bindAsEventListener(this));
			
    },

    createOverlay: function() {

        var overlay = new Element('div', {id: 'zoomyoverlay', className: 'zoomy'});
        overlay.setStyle({
            width: '100%',
            height: '100%',
            position: 'fixed',
            top: '0px',
            left: '0px',
            zIndex: '8888',
            opacity: 0.8
        });

        $(document.body).insert({
            bottom: overlay
        });
         $('zoomyoverlay').observe('click',function(event) {
            this.hideZoom();

        }.bindAsEventListener(this));
    },

    showOverlay: function(){
        if(!$('zoomyoverlay')){
            this.createOverlay();
        }
        $('zoomyoverlay').show();
    },

    hideOverlay: function() {
        $('zoomyoverlay').hide();
    }
  
});